/* Copyright (c) 1989 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* print a client error message */
/* perhaps later this routine should be more global */

#include "../copyright.h"
#include <stdio.h>
#include "../forumnet.h"
#include "externs.h"

static FILE *logfp = NULL;

/* open the logfile */

logisopen()
{
	if (logfp == NULL)
		return(0);
	return(1);
}

opensesslog(path)
char *path;
{

	if ((logfp = fopen(path, "a")) == NULL) {
		fprintf(stderr, "[Error] (log) Can't open \"%s\": ", path);
		perror("");
		return(0);
	}
	if (fchmod((int)(fileno(logfp)), 0600) != 0) {
		fprintf(stderr, "[Error] (log) Can't fchmod \"%s\": ", path);
		perror("");
		fclose(logfp);
		logfp = NULL;
		return(0);
	}
	return(1);
}

/* close the logfile */

closesesslog()
{
	if (logfp == NULL)
		return(0);
	fclose(logfp);
	logfp = NULL;
	return(1);
}

/* write an error message to the screen and log file */
puterr(s)
char *s;
{
	static char tmpbuf[132];

	if (beeping)
		putchar('\007');
	sprintf(tmpbuf, "[Error] %s", s);
	putline(tmpbuf);
}

/* write to the screen, and to the log file if open */

putline(s)
char *s;
{
	if (beeping)
		putchar('\007');
	if (logfp != NULL) {
		fputs(s, logfp);
		putc('\n', logfp);
	}
	puts(s);
}


/* only write to the log file */

lputline(s)
char *s;
{
	if (logfp != NULL) {
		fputs(s, logfp);
		putc('\n', logfp);
	}
}
