/* Copyright (c) 1989 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* routines for dealing with signals */

#include "../copyright.h"
#include <stdio.h>
#include <signal.h>
#include "../forumnet.h"
#include "externs.h"

#define	mask(s)	(1 << ((s)-1))

trapsignals()
{
	int askquit(), cmd_quit(), pause(), unpause();

	/* when we receive a deadly message, we act as if the server told */
	/* us to disconnect */
	signal(SIGHUP, cmd_quit);
	signal(SIGINT, askquit);
	signal(SIGTERM, cmd_quit);

	/* pause and unpause will fix the term modes */
	signal(SIGTSTP, pause);
/*	signal(SIGTTIN, pause); */
/*	signal(SIGTTOU, pause); */
}

pause()
{
	int omask;

	restoreterm();
	signal(SIGTSTP, SIG_DFL);
	omask = sigsetmask(sigblock(0) &~ mask(SIGTSTP));
	kill(0, SIGTSTP);
	sigblock(mask(SIGTSTP));
	signal(SIGTSTP, pause);
	setterm();
	continued = 1;
}

askquit()
{
	int c;
	int omask;

	signal(SIGINT, SIG_IGN);
	fputs("\n\rReally Quit? ", stdout);
	fflush(stdout);
	if ((c = getchar()) == EOF)
		cmd_quit();
	else {
		printf("%c\n\n", c);
		if (c == 'Y' || c == 'y')
			cmd_quit();
		else {
			sigblock(mask(SIGINT));
			signal(SIGINT, askquit);
			continued = 1;
		}
	}
}
