/* Copyright (c) 1989 Carrick Sean Casey. All rights reserved. */

/* file locking routines */

#include <stdio.h>
#include <sys/file.h>
#include <errno.h>

extern int errno;
int lockfd;

/* make a file lock using path */
/* returns 0 on success, returns 1 if already locked */
/* exits on total failure */

makelock(path)
char *path;
{
	if ((lockfd = open(path, O_RDWR | O_CREAT, 0600)) < 0) {
		perror("server: open on lock failed");
		exit(-1);
	}

	if (flock(lockfd, LOCK_EX | LOCK_NB) < 0)
		if (errno != EWOULDBLOCK) {
			perror("server: flock failed!");
			exit(-1);
		} else
			return(1);
	return(0);
}


/* unlock a previous lockfile */

unlock(path)
char *path;
{
	if (flock(lockfd, LOCK_UN | LOCK_NB) < 0)
		fprintf(stderr, "server: couldn't release lock");
	close(lockfd);
	unlink(path);
}
